<?php

/**
 * @file
 */

    /**
     * Call the WebService API to unsubscribe.
     */

    /**
     *
     */
function ebourgognenewsletter_unsubscribe($follower_id, $newsletter_id) {

  // Retrieval of token parameter.
  $parameters = drupal_get_query_parameters();

  $token = '';

  if (isset($parameters['token'])) {
    $token = $parameters['token'];
  }

  $options = array(
    'method' => 'GET',
  );

  $base_url = EBOU_NEWS_BO_API_UNSUBSCRIBE_URL . $follower_id . '/from/' . $newsletter_id . '?token=' . $token;

  $response = drupal_http_request($base_url, $options);

  if ($response->code != 200) {
    if ($response->code == 403) {
      drupal_set_message(t("Le lien de désinscription n'est pas valide. Si le probleme persiste, contactez l'assistance e bourgogne."), 'error');
    }
    else {
      drupal_set_message(t("Une erreur est survenue lors de la désincription à la newsletter. Si le probleme persiste, contactez l'assistance e-bourgogne."), 'error');
    }
  }
  else {
    drupal_set_message(t('Désinscription réussie'));
  }

  drupal_goto('/');

}

/**
 * Call the Webservice API to check the entered api key is good.
 */
function ebourgognenewsletter_check_api_key($apiKey) {
  $base_url = EBOU_NEWS_BO_API_CHECK_URL;

  $options = array(
    'headers' => array(
      'ebou-api-key' => $apiKey,
    ),
    'method' => 'GET',
  );

  $response = drupal_http_request($base_url, $options);

  if ($response->code != 200) {
    variable_set('ebourgognenewsletter_good_api_key', FALSE);

    if ($response->code == 403) {
      drupal_set_message(t("Votre clé d'API n'est pas valide. Veuillez vérifier si elle correspond bien à celle fournie par e-bourgogne. Si le problème persiste, contactez l'assistance e-bourgogne."), 'error');
    }
    else {
      drupal_set_message(t("Une erreur est survenue lors de la vérification de votre clé d'API. Si le problème persiste, contactez l'assistance e-bourgogne."), 'error');
    }
  }
  else {
    variable_set('ebourgognenewsletter_good_api_key', TRUE);
  }

  variable_set('ebourgognenewsletter_api_key', $apiKey);
}

/**
 * Retrieve the newsletter of the organism.
 */
function ebourgognenewsletter_retrieve_newsletters($apiKey) {
  $options = array(
    'headers' => array(
      'ebou-api-key' => $apiKey,
    ),
    'method' => 'GET',
  );

  $organism_id = explode(':', base64_decode($apiKey))[0];

  $base_url = EBOU_NEWS_BO_API_LIST_URL . '/' . $organism_id;

  $response = drupal_http_request($base_url, $options);

  $newslettersArray = array();

  if ($response->code != 200) {
    if ($response->code == 403) {
      drupal_set_message(t("Votre clé d'API n'est pas valide. Veuillez vérifier si elle correspond bien à celle fournie par e-bourgogne. Si le problème persiste, contactez l'assistance e bourgogne."), 'error');
    }
    else {
      drupal_set_message(t("Une erreur est survenue lors de la récuperation des newsletter. Si le probleme persiste, contactez l'assistance e-bourgogne."), 'error');
    }
  }
  else {
    $newsletters_json = json_decode($response->data, TRUE);

    $newslettersArray = array();

    foreach ($newsletters_json as $newsletter) {
      $newslettersArray[$newsletter['id']] = $newsletter['title'];
    }

    variable_set('ebourgognenewsletter_array', $newslettersArray);
  }

  return $newslettersArray;
}

/**
 *
 */
function ebourgognenewsletter_subscribe_newsletters($newsletter_id, $email) {
  $api_key = variable_get('ebourgognenewsletter_api_key', '');

  $options = array(
    'headers' => array(
      'ebou-api-key' => $api_key,
    ),
    'method' => 'POST',
  );

  $base_url = EBOU_NEWS_BO_API_ADD_URL . '/' . $newsletter_id . '?followerEmail=' . $email;

  $response = drupal_http_request($base_url, $options);

  if ($response->code != 200) {
    if ($response->code == 403) {
      drupal_set_message(t("Votre clé d'API n'est pas valide. Veuillez vérifier si elle correspond bien à celle fournie par e-bourgogne. Si le problème persiste, contactez l'assistance e bourgogne."), 'error');
    }
    else {
      drupal_set_message(t("Une erreur est survenue lors de l'inscription à la newsletter. Si le probleme persiste, contactez l'assistance e-bourgogne."), 'error');
    }
  }
  else {
    drupal_set_message(t('Vous êtes inscrit à la newsletter.'));
  }
}
